﻿//  CRT-simple shader
//
//  Copyright (C) 2011 DOLLS. Based on cgwg's CRT shader.
//
//  Includes alterations by Dale M.A. Johnson
//
//  This program is free software; you can redistribute it and/or modify it
//  under the terms of the GNU General Public License as published by the Free
//  Software Foundation; either version 2 of the License, or (at your option)
//  any later version.

#version 120

// UNIFORMS
uniform vec2 InputSize;
uniform vec2 OutputSize;
uniform vec2 TextureSize;

// OFE INPUT
attribute vec3 position;
attribute vec2 texCoords;

// OUTPUT
varying vec2 texCoord;
varying vec2 one;
varying float mod_factor;

void main()
{
        // Do the standard vertex processing.
        gl_Position = vec4(position.x, position.y, 0, 1);

        // Precalculate a bunch of useful values we'll need in the fragment
        // shader.

        // Texture coords.
        texCoord = texCoords.xy;

        // The size of one texel, in texture-coordinates.
        one = 1.0 / TextureSize;

        // Resulting X pixel-coordinate of the pixel we're drawing.
        mod_factor = texCoord.x * TextureSize.x * OutputSize.x / InputSize.x;
}